#!/bin/sh
# This file is part of sch-archive-keyring, https://gitlab.com/ts.sch.gr/sch-archive-keyring
# Copyright 2020-2021 Hellenic Schools Technical Support Team <devs@ts.sch.gr>
# SPDX-License-Identifier: GPL-3.0-or-later

# Create /etc/apt/sources.list.d/sch-archive-keyring.list

install() {
    local version_codename ubuntu_ppa debian_ppa list trusted

    version_codename=$(lsb_release -sc)
    unset ubuntu_ppa debian_ppa
    # Transform linuxmint names to respective ubuntu names
    if [ -f "/usr/share/mintsources/$version_codename/mintsources.conf" ]; then
        version_codename=$(sed -n 's/^base_codename=//p' "/usr/share/mintsources/$version_codename/mintsources.conf")
    fi
    case "$version_codename" in
    hamm | slink | potato | woody | sarge | etch | lenny | squeeze | wheezy | jessie | stretch | buster)
        # From https://www.debian.org/releases/, no PPA for them
        ;;
    bullseye)
        # A directory should exist under this URL:
        # http://ppa.launchpad.net/ts.sch.gr/debian/ubuntu/dists/
        debian_ppa="focal"
        ;;
    warty | hoary | breezy | dapper | edgy | feisty | gutsy | hardy | intrepid | jaunty | karmic | maverick | natty | oneiric | quantal | raring | saucy | utopic | vivid | wily | yakkety | zesty | artful | cosmic | disco | eoan | impish)
        # From https://wiki.ubuntu.com/Releases, no PPA for them
        ;;
    lucid | precise | trusty | xenial | bionic | focal | jammy)
        # A directory should exist under this URL:
        # http://ppa.launchpad.net/ts.sch.gr/ppa/ubuntu/dists/
        ubuntu_ppa="$version_codename"
        ;;
    *)
        echo "Άγνωστη έκδοση: $version_codename" >&2
        ;;
    esac
    rm -f /etc/apt/sources.list.d/ts?sch?gr*
    rm -f /etc/apt/trusted.gpg.d/ts?sch?gr*
    list=/etc/apt/sources.list.d/sch-archive-keyring.list
    if grep -qs "sch-archive-keyring-updated-for: $version_codename" "$list"; then
        echo "Ήδη ενημερωμένο: $list"
    else
        rm -f /etc/apt/sources.list.d/sch-archive-keyring.*
        {
            if command -v apt >/dev/null; then
                trusted="[trusted=yes] "
            else
                unset trusted
            fi
            printf "\
# Αποθετήρια λογισμικού της Υπηρεσίας Τεχνικής Στήριξης ΣΕΠΕΗΥ.
# Μπορείτε να τα διαχειριστείτε με την εντολή: software-properties-gtk
# Επαναδημιουργούνται αυτόματα εάν αλλάξει η έκδοση του λειτουργικού.
# sch-archive-keyring-updated-for: %s

deb %shttp://ts.sch.gr/repo stable main #Αποθετήριο εκπαιδευτικού λογισμικού
" "$version_codename" "$trusted"
            if [ -n "$ubuntu_ppa" ]; then
                printf "\
deb http://ppa.launchpad.net/ts.sch.gr/ppa/ubuntu %s main #Αποθετήριο ενημερώσεων ΣΕΠΕΗΥ
# deb http://ppa.launchpad.net/ts.sch.gr/proposed/ubuntu %s main #Αποθετήριο ελέγχου ενημερώσεων ΣΕΠΕΗΥ
" "$ubuntu_ppa" "$ubuntu_ppa"
            elif [ -n "$debian_ppa" ]; then
                printf "\
deb http://ppa.launchpad.net/ts.sch.gr/debian/ubuntu %s main #Αποθετήριο ΣΕΠΕΗΥ με Debian
" "$debian_ppa"
            fi
        } >"$list"
        printf "\
Δημιουργήθηκε: %s
Εκτελέστε: apt-get update
" "$list"
    fi
}

set -e

# http://www.debian.org/doc/debian-policy/ch-maintainerscripts.html#s-mscriptsinstact
# The postinst script may be called in the following ways:
# <postinst> configure <most-recently-configured-version>
# <old-postinst> abort-upgrade <new version>
# <conflictor's-postinst> abort-remove in-favour <package> <new-version>
# <postinst> abort-remove
# <deconfigured's-postinst> abort-deconfigure in-favour
#     <failed-install-package> <version>
#     [removing <conflicting-package> <version>]
#
# But it also can be called like this, from dpkg-reconfigure <package>:
# <postinst> reconfigure <most-recently-configured-version>

case "$1" in
configure | abort-upgrade | abort-remove | abort-deconfigure)
    install "$@" || true
    ;;
*)
    echo "postinst called with unknown argument \`$1'" >&2
    exit 1
    ;;
esac

# dh_installdeb will replace this with shell code automatically
# generated by other debhelper scripts.

#DEBHELPER#

exit 0
